#!/usr/bin/env node

const program = require("../node_modules/commander")
const chalk = require("../node_modules/chalk")
const ora = require("../node_modules/ora")
const download = require("../node_modules/download-git-repo")
const tplObj = require(`${__dirname}/../template`)

program.usage("<template-name> [project-name]")
program.parse(process.argv)
// 当没有输入参数的时候给个提示
if (program.args.length < 1) return program.help()

// 好比 vue init webpack project-name 的命令一样，第一个参数是 webpack，第二个参数是 project-name
let templateName = program.args[0]
let projectName = program.args[1]
// 小小校验一下参数
if (!tplObj[templateName]) {
  console.log(chalk.red("\n Template does not exit! \n "))
  return
}
if (!projectName) {
  console.log(chalk.red("\n Project should not be empty! \n "))
  return
}

url = tplObj[templateName]

console.log(chalk.white("\n Start generating... \n"))
// 出现加载图标
const spinner = ora("Downloading...")
spinner.start()
// 执行下载方法并传入参数
download(url, projectName, err => {
  if (err) {
    spinner.fail()
    console.log(chalk.red(`Generation failed. ${err}`))
    return
  }
  // 结束加载图标
  spinner.succeed()
  console.log(chalk.green("\n 拉取成功~快开始吧~"))
  console.log(chalk.green(`\n    cd ${projectName} \n`))
  console.log(chalk.green(`\n    npm i \n`))
  console.log(chalk.green(`\n    npm run dev \n`))
})
